/**
 * 
 */
package luento04;

/**
 * @author vesal
 * @version 18.1.2022
 *
 */
public class Alkuluku {

    /**
     * Aliohjelmalla tutkitaan onko parametrina tuotu
     * luku alkuluku vai ei<br>
     * 
     * @param luku tutkittava luku
     * @return 1 jos alkuluku, muuten millä jaollinen
     * @example
     * <pre name="test">
     *   millaJaollinen(25)  === 5;
     *   millaJaollinen(2)   === 1;
     *   millaJaollinen(4)   === 2;
     *   millaJaollinen(123) === 3;
     *   millaJaollinen(7)   === 1;    
     * </pre>
     */
    public static int millaJaollinen(int luku) {
        /* 
         Algoritmi: Jaetaan tutkittavaa lukua jakajilla 2,3,5,7...luku/2.
         Jos jokin jako menee tasan, niin ei alkuluku:
        */
        if (luku == 2) return 1;
        int jakaja = 2;
        int kasvatus = 1;

        do {
            int jakojaannos = luku % jakaja;
            if (jakojaannos == 0) return jakaja;
            jakaja += kasvatus;
            kasvatus = 2;
        } while (jakaja < luku/2); 
        return 1;
    }
    
    
    
    /**
     * @param args Ei käytössä
     */
    public static void main(String[] args) {
        int luku = 25;
        int jaollinen;

        jaollinen = millaJaollinen(luku);

        if ( jaollinen == 1)
           System.out.println("alkuluku");
        else
            System.out.println("Jaollinen luvulla " + jaollinen);
    }

}
