/**
 * 
 */
package testaaminen;

/**
 * Esimerkki testaamisesta 
 * @author vesal
 * @version 31.1.2022
 *
 */
public class Poista {

    /**
     * Poistetaan jonosta esiintymät niin ettei siinä ole yhtään
     * poistettava osajonoa. 
     * @param jono Mistä poistetaan
     * @param poistettava mitä poistetaan
     * @return jono ilman poistettavaa
     * @example
     * <pre name="test">
     *   poista("Catcat"   ,"at")  =>  "Cc";
     *   poista("Paatti"   ,"at")  ===  "Pi";
     *   poista("Puatit"   ,"at")  ===  "Puit";
     *   poista("Abba"     ,"bb")  ===  "Aa";
     *   poista("Abbababba","ba")  ===  "Abb";
     *   poista("AbbabaaB" ,"ba")  ===  "AB";
     *   poista("Abba"     ,"Ab")  ===  "ba";
     *   poista("Abba"     ,"cc")  ===  "Abba";
     *   poista("Abba"     ,""  )  ===  "Abba";
     *   poista(""         ,"Aa")  ===  "";
     *   poista(""         ,""  )  ===  "";
     *   poista(null       ,""  )  ===  "";
     *   poista(null       ,"k"  ) ===  "";  // # THROWS NullPointerException
     *   poista("Kissa"    ,null)  ===  "Kissa";
     * </pre>     */
    public static String poista(String jono, String poistettava) {
        return demo.d3.Poista.poista(jono, poistettava); 
    }
    

    private static int poistatesti(String jono, String mita, String odotettuTulos) {
        String vaihdettu = poista(jono, mita);
        if ( vaihdettu.equals(odotettuTulos ) ) return 0;
        System.out.println(jono + " => " + vaihdettu + " piti tulla "
                + odotettuTulos);        
        return 1;
    }
    
    
    /**
     * Testataan poista-aliohjelmaa
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        int v = 0;
        v += poistatesti("Catcat", "at", "Cc");
        v += poistatesti("Paatti", "at", "Pi");
        v += poistatesti("Puatit", "at", "Puit");
        v += poistatesti("Abba", "bb", "Aa");
        System.out.println("Virheitä oli: " + v);
    }
}
