package elukat;

import java.util.ArrayList;

/**
 * Koira joka laajentaa eläimen ominaisuudet
 * @author vesal
 * @version 25.1.2011
 * @example
 * <pre name="test">
 *   Koira miuku = new Koira("Musti",2300);
 *   miuku.toString() === "Musti 2300.0";
 * </pre>
 */
public class Koira extends Elain {

    /**
     * Alustetaan koiran tiedot
     * @param nimi koiran nimi
     * @param paino koiran paino
     */
    public Koira(String nimi, double paino) {
        super(nimi, paino);
    }


    /**
     * Ääntelee kuin koira
     */
    @Override
    public void aantele() {
        System.out.println("Hau hau");
    }


    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Koira pluto = new Koira("Pluto", 12000);
        Koira musti = new Koira("Musti", 1000);

        pluto.aantele(); // hau hau
        musti.aantele(); // hau hau

        System.out.println(pluto);
        //        pluto.kasva();
        System.out.println(pluto);
        System.out.println(musti);

        
        // Polymorfismi (perinnän tai rajapintojen ansiosta)
        ArrayList<Elain> elukat = new ArrayList<>();
        elukat.add(pluto);
        elukat.add(new Kissa("Mirri",500));
        elukat.add(new Kissa("Miuku",18000));
        
        for (Elain elain : elukat) {
            elain.aantele();
            System.out.println(elain);
        }

    }
}