package laskuri;

import java.io.IOException;

/**
 * Ohjelmalla lasketaan tiedostossa olevien sanojen
 * esiintymismääriä.
 *<pre>
 * Tarvitaan luokat:
 * Sana
 * - lisää laskuria
 * - tunnista sana
 *
 * Sanat
 * - lue tiedosto
 * - etsi sana
 * - pätki rivi
 *
 * Algoritmi:
 * 1) Lue tiedostosta rivi.
 * 2) Pätki rivi sanoiksi
 * 3) Lisää kunkin sanan esiintymismäärää yhdellä
 *      - jos sanaa ei vielä ole ennestään, lisää sana
 * 4) jatka 1) kunnes koko tiedosto käsitelty
 *
 *</pre>
 * @author Vesa Lappalainen
 * @version 1.0, 21.02.2003
 */
public class Sanalaskuri {

    /**
     * Lasketaan tiedostossa olevat sanat
     * @param args ei käytössä
     */
    public static void main(String[] args)  {
        try {
            Sanat sanat = new Sanat();
            sanat.lueTiedostoJaLaske("kalevala.txt");
            sanat.tulosta(System.out);
        } catch (IOException e) {
            System.err.println(e.getMessage());
        }
    }
}