package guiAanestys;

import java.awt.BorderLayout;
import java.awt.EventQueue;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import java.awt.Font;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import java.awt.Component;
import javax.swing.Box;
import javax.swing.JOptionPane;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import valinta.Vaihtoehdot2;
import valinta.Valinta;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import fi.jyu.mit.gui.AbstractChooser;
import fi.jyu.mit.gui.IStringListChooser;
import fi.jyu.mit.gui.RadioButtonChooser;
import fi.jyu.mit.gui.SelectionChangeListener;

/**
 * Pieni esimerkki äänestys-ohjelmasta joka on toteutettu oliotaulukon avulla.
 *  
 * @author vesal
 * @version 6.2.2011
 */
public class SwingAanestys extends JFrame {

    /**
     * Testataan gui-äänestysliitymää
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Vaihtoehdot2 valinnat = new Vaihtoehdot2(10);
        
        valinnat.lisaa(new Valinta('K',"Kyllä"));
        valinnat.lisaa(new Valinta('E',"Ei"));
        valinnat.lisaa(new Valinta('O',"EOS"));
        SwingAanestys.aanesta(valinnat, "Onko ohjelmointi kivaa","Äänestit siis");
        /*
        valinnat.lisaa(new Valinta('T', "Tyttö"));
        valinnat.lisaa(new Valinta('P', "Poika"));
        valinnat.lisaa(new Valinta('N', "Nainen"));
        valinnat.lisaa(new Valinta('M', "Mies"));
        */
        //SwingAanestys.aanesta(valinnat, "Mitä sukupuolta olet","Olet siis");
    }


    private static final long serialVersionUID = 1L;
    private JPanel contentPane;
    private final JLabel labelAihe = new JLabel("Onko ohjelmointi kivaa?");
    private final JPanel panelAanestys = new JPanel();
    private final JButton buttonAanesta = new JButton("\u00C4\u00E4nest\u00E4");
    private final Component verticalStrut = Box.createVerticalStrut(20);
    private final JLabel labelValittu = new JLabel(" ");
    private final JPanel panelValittu = new JPanel();
    private final AbstractChooser<String> valinta = new RadioButtonChooser();
    private final JPanel panelAanestaButton = new JPanel();
    private Vaihtoehdot2 vaihtoehdot;
    private String toteamus = "Äänestit siis";

    

    /**
     * Aloitetaan äänestys
     * @param valinnat lista valinnoista, joita voidaan tehdä
     * @param alkuteksti teksti joka näytetään lomakkeen yläotsikkona 
     * @param toteamus teksti joka tulee jokaisen äänestyksen jälkeen.
     */
    public static void aanesta(final Vaihtoehdot2 valinnat, final String alkuteksti, final String toteamus) {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Throwable e) {
            //
        }
        EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                try {
                    SwingAanestys frame = new SwingAanestys();
                    frame.setKohteet(valinnat, alkuteksti,toteamus);
                    frame.setVisible(true);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }
    
    
    /**
     * Alusteaan lomake
     */
    public SwingAanestys() {
        setTitle("\u00C4\u00E4nestys");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setBounds(100, 100, 245, 306);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        contentPane.setLayout(new BorderLayout(0, 0));
        setContentPane(contentPane);
        labelAihe.setFont(new Font("Arial", Font.BOLD, 19));
        
        contentPane.add(labelAihe, BorderLayout.NORTH);
        contentPane.add(panelAanestys, BorderLayout.CENTER);
        panelAanestys.setBorder(new EmptyBorder(20, 20, 20, 20));
        panelAanestys.setLayout(new BoxLayout(panelAanestys, BoxLayout.Y_AXIS));
        valinta.setCaption("Valitse");
        valinta.addSelectionChangeListener(new SelectionChangeListener<String>() {
            @Override
            public void selectionChange(IStringListChooser<String> sender) {
                valintaVaihtui();
            }
        });
        
        panelAanestys.add(panelValittu);
        labelValittu.setName("valittu");
        panelValittu.add(labelValittu);
        labelValittu.setHorizontalAlignment(SwingConstants.LEFT);
        
        valinta.setName("valinta");
        valinta.setMnemonics("KEO");
        valinta.setKohteet(new String[] {"Kyll\u00E4", "Ei", "En osaa sanoa"});
        valinta.setSelectedIndex(0);
        
        panelAanestys.add(valinta);
        panelAanestys.add(verticalStrut);
        
        panelAanestys.add(panelAanestaButton);
        panelAanestaButton.add(buttonAanesta);
        buttonAanesta.setHorizontalAlignment(SwingConstants.LEADING);
        buttonAanesta.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent arg0) {
                aanesta();
            }
        });
        getRootPane().setDefaultButton(buttonAanesta);    }


    /// Omat aliohjelmat

    /**
     * Laitetaan kohteet ja tekstit.
     * @param valinnat lista valinnoista, joita voidaan tehdä
     * @param alkuteksti teksti joka näytetään lomakkeen yläotsikkona 
     * @param toteamus teksti joka tulee jokaisen äänestyksen jälkeen.
     */
    public void setKohteet(Vaihtoehdot2 valinnat, String alkuteksti, String toteamus) {
        vaihtoehdot = valinnat;
        labelAihe.setText(alkuteksti);
        this.toteamus = toteamus;
        valinta.setKohteet(valinnat.getKohteet());
        valinta.setMnemonics(valinnat.getKirjaimet());
    }
    

    /**
     * Vaihdetaan valinnan tekstiä 
     * @example
     * <pre name="test">
     * #import javax.swing.*;
     * #import valinta.Vaihtoehdot2;
     * #import valinta.Valinta;
     *   comtest.GUITester g = new comtest.GUITester();
     *   SwingAanestys frame = new SwingAanestys();
     *   Vaihtoehdot2 valinnat = new Vaihtoehdot2(10);
     *   valinnat.lisaa(new Valinta('K',"Kyllä"));
     *   valinnat.lisaa(new Valinta('E',"Ei"));
     *   valinnat.lisaa(new Valinta('O',"En osaa sanoa"));
     *   frame.setKohteet(valinnat, "Onko ohjelmointi kivaa","Äänestit siis");
     *   g.showWindow(frame);
     *   JLabel l = g.getComponent(JLabel.class,g.where.nameIs("valittu"));
     *   l.getText() =R= "Valittu: Kyllä";
     *   JComponent rb = g.getComponent(JComponent.class,g.where.textIs("Ei")); 
     *   g.click(rb);
     *   l.getText() === "Valittu: Ei";
     *   
     *   #import fi.jyu.mit.gui.AbstractChooser;   
     *   AbstractChooser<String> valinta = g.getComponent(AbstractChooser.class,g.where.nameIs("valinta"));
     *   valinta.setSelectedIndex(2);   
     *   l = g.getComponent(JLabel.class,g.where.nameIs("valittu"));
     *   l.getText() === "Valittu: En osaa sanoa";
     * </pre>
     */
    protected void valintaVaihtui() {
        labelValittu.setText("Valittu: "+valinta.getSelectedText());        
    }


    /**
     * Äänestetään valittua kohdetta
     * @example
     * <pre name="test">
     * #import javax.swing.*;
     *   comtest.GUITester g = new comtest.GUITester();
     *   SwingAanestys frame = new SwingAanestys();
     *   Vaihtoehdot2 valinnat = new Vaihtoehdot2(10);
     *   valinnat.lisaa(new Valinta('K',"Kyllä"));
     *   valinnat.lisaa(new Valinta('E',"Ei"));
     *   valinnat.lisaa(new Valinta('O',"En osaa sanoa"));
     *   frame.setKohteet(valinnat, "Onko ohjelmointi kivaa","Äänestit siis");
     *   g.showWindow(frame);
     *   JButton buttonAanesta = g.getComponent(JButton.class,g.where.textMatches(".*Äänes.*"));
     *   
     *   g.click(buttonAanesta);
     *   JLabel l = g.getComponent(JLabel.class,g.where.textMatches(".*Äänes.*"));
     *   l.getText() =R= ".*Äänestit siis: <b>Kyllä.*"; 
     *   g.click(g.getComponent(JButton.class,g.where.textIs("OK")));
     *   
     *   JComponent rb = g.getComponent(JComponent.class,g.where.textIs("Ei")); 
     *   g.click(rb);
     *   g.click(buttonAanesta);
     *   l = g.getComponent(JLabel.class,g.where.textMatches(".*Äänes.*"));
     *   l.getText() =R= ".*Äänestit siis: <b>Ei.*"; 
     *   g.click(g.getComponent(JButton.class,g.where.textIs("OK")));
     *   
     *   rb = g.getComponent(JComponent.class,g.where.textIs("En osaa sanoa")); 
     *   g.click(rb);
     *   g.click(buttonAanesta);
     *   l = g.getComponent(JLabel.class,g.where.textMatches(".*Äänes.*"));
     *   l.getText() =R= ".*Äänestit siis: <b>En osaa sanoa.*";  
     *   g.click(g.getComponent(JButton.class,g.where.textIs("OK")));
     *   
     * </pre>
     */
    protected void aanesta() {
        String kohde = "";
        int i = valinta.getSelectedIndex();
        if ( i >= 0 ) kohde = valinta.getSelectedText();
        if ( vaihtoehdot == null ) {
            JOptionPane.showMessageDialog(null, toteamus + ": " + kohde);
            return;            
        }
        vaihtoehdot.anna(i).lisaa();
        JOptionPane.showMessageDialog(null, "<html>" + toteamus + ": <b>" + kohde + "</b>" +
            vaihtoehdot.aanetAsHTMLTable() +    
            "</html>");
    }

}